#ifndef CONGESTIONWINDOW_H
#define CONGESTIONWINDOW_H

#include <vector>
#include <iostream>

#define	INTVECTOR	std::vector<int>
#define COUT	std::cout

class CongestionWindow{
public:
//************************** size = 1
	CongestionWindow(int buffersize) {size = 1; this->buffersize = buffersize;}
	virtual ~CongestionWindow() {}
	
	virtual void receivedDupAck() = 0;
	virtual void timedOut() = 0;
	virtual void packetAcked() = 0;
	
	int getSize() { return size;}
	virtual bool ifAutoReSend() = 0;

protected :
	int size ;
	int buffersize;
};

class AIMD : public CongestionWindow{
public:

	AIMD(int buffersize) : CongestionWindow(buffersize) { fraction = 0;}
	virtual void receivedDupAck() {}
	virtual void timedOut();
	virtual void packetAcked();
	virtual bool ifAutoReSend() { return false;}

protected:
	float fraction;
};

class SSAIMD : public AIMD{
public:
	SSAIMD(int buffersize) : AIMD(buffersize) { threshold = -1;}
	
	virtual void timedOut();
	virtual void packetAcked();

protected:
	int threshold;
};

class SSAIMDFR : public SSAIMD{
public:
	SSAIMDFR(int buffersize) : SSAIMD(buffersize) {}
	virtual void receivedDupAck();

	virtual bool ifAutoReSend() { return true;}
};

class SSAIMDFRFR : public SSAIMDFR{
public:
	SSAIMDFRFR(int buffersize) : SSAIMDFR(buffersize) {}

	virtual void receivedDupAck();
	virtual void timedOut();
};

#endif // CONGESTIONWINDOW_H
