#include <unistd.h>
#include <sys/types.h>
#include <signal.h>

#include <pthread.h>
#include <semaphore.h>

#include <time.h>
#include <vector>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include "Pipe.h"
#include "Message.h"
#include "SenderSlidingWindow.h"

#define	BufferItemVECTOR	std::vector<BufferItem>
#define	COUT	std::cout
#define	CIN		std::cin

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
sem_t sem;
sem_t timesem;


SendPipe sender("NETRECFMSRC");
ReceivePipe receiver("NETSNDTOSRC");
SenderSlidingWindow senderSligingWindow ;

int x, y;
int the_clock = 0;

void timer(int signum)
{
	the_clock++;
	
	sem_post (&timesem);		
}

void * time_cleaner(void * parameter)
{
	while(true)
	{
		sem_wait (&timesem);
//		COUT <<"&&& Time is " << the_clock << '\n';
		
		senderSligingWindow.Tick();
	}
	
	return NULL;
}

void * sender_thread(void * parameter)
{
	while (true )
	{
		//@todo .
		// Do the concurreny control below.
//**************** I disabled mutexes !!
//		pthread_mutex_lock(&mutex);//{
		BufferItemVECTOR whatToSend  = senderSligingWindow.whatToSend();
//		pthread_mutex_unlock(&mutex);//}
		COUT << "Numbre of the packets wich must be transmitted is "<< whatToSend.size()<<"\n";
		int stop ;
//		CIN >> stop;
		COUT << "****************************************************************\n";
		for(int i = 0; i < whatToSend.size(); i++)
		{			
			//***********************8 DIDI HALA !!!!
			sender.send(Message(-1, -1, ( (BufferItem)whatToSend[i]).getSeqNO(), the_clock));

			COUT << "A packet with id "<< ( (BufferItem)whatToSend[i]).getSeqNO() << " has already sent at "<< the_clock<<"\n";

		}	
		COUT << "****************************************************************\n";									
	}	
	return NULL;
}

void * receiver_thread(void * parameter)
{
	while (true )
	{
		Message msg = receiver.receive();
		senderSligingWindow.gottenAck(msg.getAcked(),msg.getValue());
		printf("Acked: %s", msg.toString().c_str());

	}

	return NULL;
}

void init()
{
	sem_init (&sem, 0, 0);
	sem_init (&timesem, 0, 0);
	
	srand( time(0));
	
	x = rand() % 20;

	signal(SIGUSR1, &timer);

	{
		SendPipe PIDSender("SENDERTELLPID");
		
		Message m( 0, 0, 0, getpid());
		PIDSender.send(m);
		printf("PID: %ld\n", m.getTimeStamp());	
	}	
}

int main(int argc, char *argv[])
{
	init();
	
	//Handshaking....
	sender.send(Message(0, -1, x, 0));
	
	Message m = receiver.receive();
	y = m.getValue();
	
	sender.send(Message(0, y + 1, -1, 0));
	
	printf("x: %d, y: %d\n", x, y);
			
	pthread_t for_send;
	pthread_t for_receive;
	pthread_t for_time;
	
	pthread_create(&for_send, NULL, &sender_thread, NULL);
	pthread_create(&for_receive, NULL, &receiver_thread, NULL);
	pthread_create(&for_time, NULL, &time_cleaner, NULL);
	
	
	pthread_join(for_send, NULL);
	pthread_join(for_receive, NULL);
	pthread_join(for_time, NULL);

	return 0;
}
