#include <sys/types.h>
#include <signal.h>
#include <stdio.h>
#include "Pipe.h"

int main(int argc, char *argv[])
{
	long npid;
	long spid;
	long rpid;
	
	{
		ReceivePipe receiver("NETWORKTELLPID");
		Message m = receiver.receive();
		printf("NPID: %d\n", npid = m.getTimeStamp());
	}
	
	{
		ReceivePipe receiver("SENDERTELLPID");
		Message m = receiver.receive();
		printf("SPID: %d\n", spid = m.getTimeStamp());
	}
	
	{
		ReceivePipe receiver("RECEIVERTELLPID");
		Message m = receiver.receive();
		printf("RPID: %d\n", rpid = m.getTimeStamp());
	}
		
	for(long i = 0; i < 10000; i++)
	{
		usleep(1000);
		
		if(i % 2 == 0)
			printf("Tick -\n");
		else
			printf("Tack |\n");
		
		if( kill( npid, SIGUSR1) != 0)
		{
			printf("The network process is not there to be signalled.\n");
			return 1;
		}

		if( kill( spid, SIGUSR1) != 0)
		{
			printf("The sender process is not there to be signalled.\n");
			return 1;
		}

		if( kill( rpid, SIGUSR1) != 0)
		{
			printf("The receiver process is not there to be signalled.\n");
			return 1;
		}
	}	
	
	return 0;
}
